package it.finazzo.ds;

import it.finazzo.bean.Libro;
import it.finazzo.factory.LibroFactory;

import java.util.Collection;
import java.util.Iterator;

import net.sf.jasperreports.engine.JRDataSource;
import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JRField;

@SuppressWarnings("unchecked")
public class DataSource implements JRDataSource {

	Collection<Libro> beanCollection = (Collection<Libro>) LibroFactory.getBeanCollection();
	private Iterator<Libro> iterator = beanCollection.iterator();
	private Libro libro = null;
	int counter = 0;
	
	@Override
	public boolean next() throws JRException {
		
		if (counter>=beanCollection.size())
			return false;
		libro = iterator.next();
		counter++;
		return true;
	}
	
	@Override
	public Object getFieldValue(JRField arg0) throws JRException {
		if (arg0.getName().equals("autore"))
			return libro.getAutore();
		if (arg0.getName().equals("id"))
			return libro.getId();
		if (arg0.getName().equals("titolo"))
			return libro.getTitolo();
		if (arg0.getName().equals("genere"))
			return libro.getGenere();
		return null;
	}

}
